#!/usr/bin/python
# -*- coding:utf-8 -*-

import os, sys, Levenshtein
xml_zh=sys.argv[1]
xml_en=sys.argv[2]
edits_zh='edits.zh/'
edits_en='edits.en/'
ann_zh='ann.zh/'
ann_en='ann.en/'
file_idx= ['{0:0>3}'.format(i) for i in range(1,326)]

def get_paragraphs(infile,encoding):
	open_infile=open(infile,'r')
	inlines=open_infile.read().decode(encoding).strip().split('\n')
	open_infile.close()
	paragraphs=[]
	para=''
	headline_skipped=False
	get_next=False
	for line in inlines:
		if line.startswith('<HEADLINE>'):
			headline_skipped=False
		elif line.startswith('</HEADLINE>'):
			headline_skipped=True
		elif line.startswith('<P>'):
			para=''
		elif line.startswith('</P>'):
			paragraphs.append(para)
		elif line.startswith('<S'):
			get_next=True
		elif line.startswith('</S'):
			get_next=False
		elif headline_skipped and (get_next or not line.startswith('<')):
			para+=line.strip()+' '
                        get_next=False
	paragraphs=[para.strip() for para in paragraphs] 
	paragraphs=[para for para in paragraphs if len(para)>0]
	output='\n'.join(paragraphs)
	return unicode(output)

def revise(original,edit_file,ann_file):
	openfile=open(edit_file,'r')
	diff_edits=openfile.read().decode('utf-8').strip()
	openfile.close()
	[diff,edits]=diff_edits.split('\t')
	if edits!='nil':
		edits=edits.split(',')
		edits=[edit.split('_') for edit in edits]
		edits=[(str(edit[0]),int(edit[1]),int(edit[2])) for edit in edits]
		revision=Levenshtein.apply_edit(edits,original,diff)
	else:
		revision=original
	openfile=open(ann_file,'r')
	inlines=openfile.read().decode('utf-8').split('\n')
	openfile.close()
	output='\n'.join(inlines[:3])+'\n'+revision.strip()+'\n'+'\n'.join(inlines[3:]).strip()
	outfile=open(ann_file,'w')
	outfile.write(output.encode('utf-8')+'\n')
	outfile.close()

def get_annotations():
   for i in file_idx:
	txt_zh=get_paragraphs(xml_zh+'/CHTB_'+i+'.RAW','gb18030')
	revise(txt_zh,edits_zh+i,ann_zh+i)
	txt_en=get_paragraphs(xml_en+'/'+[f for f in os.listdir(xml_en) if f.startswith('chtb_'+i)][0],'gb18030')
	revise(txt_en,edits_en+i,ann_en+i)

get_annotations()
